;##################################################################
; GdipScribble
;##################################################################

STRINGS UNICODE

#include "GdipScribble.h"

#Define S @ADDRESSWIDTH/8

CONST SECTION
	ImageEncoderBMP GUID GUID_ImageEncoderBMP
	ImageEncoderJPEG GUID GUID_ImageEncoderJPEG
	ImageEncoderPNG GUID GUID_ImageEncoderPNG
	ImageEncoderGIF GUID GUID_ImageEncoderGIF
	ImageEncoderTIFF GUID GUID_ImageEncoderTIFF
	ImageEncoderEMF GUID GUID_ImageEncoderEMF
	ImageEncoderWMF GUID GUID_ImageEncoderWMF
	ImageEncoderICON GUID GUID_ImageEncoderICON

	BlurEffectGuid GUID GUID_BlurEffectGuid
	BrightnessContrastEffectGuid GUID GUID_BrightnessContrastEffectGuid
	ColorBalanceEffectGuid GUID GUID_ColorBalanceEffectGuid
	ColorCurveEffectGuid GUID GUID_ColorCurveEffectGuid
	ColorLookupTableEffectGuid GUID GUID_ColorLookupTableEffectGuid
	ColorMatrixEffectGuid GUID GUID_ColorMatrixEffectGuid
	HueSaturationLightnessEffectGuid GUID GUID_HueSaturationLightnessEffectGuid
	LevelsEffectGuid GUID GUID_LevelsEffectGuid
	RedEyeCorrectionEffectGuid GUID GUID_RedEyeCorrectionEffectGuid
	SharpenEffectGuid GUID GUID_SharpenEffectGuid
	TintEffectGuid GUID GUID_TintEffectGuid

DATA SECTION
	GDIPlusToken	ULONG_PTR			0
	gdipsi			GdiplusStartupInput	<1,0,0,0>
	pPic			PTR ?

	CustColor		COLORREF 16 dup (?)

	// Handles used in the example
	hInstance	HANDLE ?
	hPencil		HANDLE ?
	hPictureBox	HANDLE ?
	hAlpha		HANDLE ?

	fDrawing	BOOL ?
	Oldpt		POINT <>

	// The SCHAR type changes to DUS when STRINGS UNICODE is defined
	BmpEditClass		SCHAR	"Picturebox_class",0

CODE SECTION

START:
	invoke GetModuleHandle, 0
	mov [hInstance],eax
	invoke InitClasses
	// COM must be initialized
	invoke CoInitialize,NULL
	// Turn on common controls
	invoke InitCommonControls
	// Start GDI+
	invoke GdiplusStartup,offset GDIPlusToken,offset gdipsi,NULL

	// Display the dialog
	invoke DialogBoxParam,[hInstance],1000,0,ADDR DlgProc,0

	invoke GdiplusShutdown,[GDIPlusToken]
	// Turn COM off
	invoke CoUninitialize
	invoke ExitProcess,0

InitClasses FRAME
	LOCAL cix:WNDCLASSEX

	invoke RtlZeroMemory,offset cix,SIZEOF WNDCLASSEX

	// Load the pencil cursor
	invoke LoadImage,NULL,"Cursors\Pencil.cur",IMAGE_CURSOR,0,0,LR_LOADFROMFILE
	mov [hPencil],rax
	mov [cix.hCursor],rax

	mov D[cix.style],CS_OWNDC or CS_HREDRAW or CS_VREDRAW
	mov D[cix.cbSize],SIZEOF WNDCLASSEX
	mov rax,[hInstance]
	mov [cix.hInstance],rax
	mov S[cix.lpszClassName],offset BmpEditClass
	mov D[cix.cbWndExtra],28
	mov D[cix.cbClsExtra], NULL
	mov S[cix.hbrBackground], NULL
	mov S[cix.lpfnWndProc], offset PictureBoxProc
	invoke RegisterClassEx,offset cix

	RET
ENDF

DlgProc FRAME hwnd,uMsg,wParam,lParam
	uses ebx
	cmp D[uMsg],WM_INITDIALOG
	jne >>.WM_COMMAND
		invoke GetDlgItem,[hwnd],1001
		mov [hPictureBox],eax
		invoke GetDlgItem,[hwnd],1004
		mov [hAlpha],eax
		invoke SendMessage,[hAlpha],TBM_SETRANGE,FALSE,255<<16
		invoke SendMessage,[hAlpha],TBM_SETPOS,TRUE,255
		invoke SetDlgItemInt,[hwnd],1007,255,TRUE
		invoke GetDlgItem,[hwnd],1007
		invoke SendMessage,[hAlpha],TBM_SETBUDDY,NULL,eax
		// We'll start with red
		invoke SetWindowLong,[hPictureBox],0,Red
		jmp >>.EXIT

	.WM_COMMAND
	cmp D[uMsg],WM_COMMAND
	jne >.WM_VSCROLL
		invoke ColorDlg,[hwnd],0FF000000h
		// have to reverse the byte order of the colors for GDI+
		mov ebx,eax
		bswap ebx
		shr ebx,8
		// Have to set the alpha channel !!!
		invoke SendMessage,[hAlpha],TBM_GETPOS,0,0
		shl eax,24
		or eax,ebx
		invoke SetWindowLong,[hPictureBox],0,eax
		jmp >>.EXIT

	.WM_VSCROLL
	cmp D[uMsg],WM_VSCROLL
	jne >.WM_NOTIFY
			// We will not use the WM_VSCROLL message to actually set the alpha
			// channel value, only to display it in the buddy. The channel will
			// be set with the NM_RELEASEDCAPTURE notification, that way it will
			// only change when the user stops scrolling
			invoke SendMessage,[hAlpha],TBM_GETPOS,0,0
			invoke SetDlgItemInt,[hwnd],1007,eax,TRUE
			jmp >>.DEFPROC

	.WM_NOTIFY
	cmp D[uMsg],WM_NOTIFY
	jne >.WM_CLOSE
		mov ebx,[lParam]
		cmp D[ebx+NMHDR.code],NM_RELEASEDCAPTURE
		jne >>.DEFPROC
			invoke GetWindowLong,[hPictureBox],0
			and eax,0FFFFFFh
			mov ebx,eax
			invoke SendMessage,[hAlpha],TBM_GETPOS,0,0
			shl eax,24
			or eax,ebx
			invoke SetWindowLong,[hPictureBox],0,eax
			xor eax,eax
			ret

	.WM_CLOSE
	cmp D[uMsg],WM_CLOSE
	jne >.DEFPROC
		INVOKE EndDialog,[hwnd],0

	.DEFPROC
		mov eax,FALSE
		ret

	.EXIT

	mov eax, TRUE
	ret
ENDF

ColorDlg FRAME hWin, InitColor
	;Common dialog process
	LOCAL ccl:CHOOSECOLOR
	LOCAL crv[16]:D

	lea edi,crv
	mov ecx,16
	mov eax,0FFFFFFFFh
	rep stosd

	mov D[ccl.lStructSize],sizeof CHOOSECOLOR
	push [hWin]
	pop [ccl.hwndOwner]
	push [hInstance]
	pop [ccl.hInstance]
	mov eax,[InitColor]
	mov [ccl.rgbResult],eax

	; address of 16 item DWORD array
	mov D[ccl.lpCustColors],OFFSET CustColor
	mov D[ccl.Flags],CC_ANYCOLOR | CC_RGBINIT
	mov D[ccl.lCustData],NULL
	mov S[ccl.lpfnHook],NULL
	mov S[ccl.lpTemplateName],NULL

	invoke ChooseColor,addr ccl

	;Is the colordialog canceled
	test eax,eax
	jz >
		mov eax,[ccl.rgbResult]
		ret
	:
		mov eax,-1
	ret
ENDF

PictureBoxProc FRAME hwnd, uMsg, wParam, lParam
	uses ebx,esi,edi
	LOCAL ps		:PAINTSTRUCT
	LOCAL rect		:RECT
	LOCAL pt		:POINT
	LOCAL pGraphics	:%PTR
	LOCAL bmd		:BitmapData
	LOCAL color		:%COLORREF

// Window memory
// GWL_USERDATA = Current bitmap
// 0 = current color

	.WM_CREATE
	cmp D[uMsg],WM_CREATE
	jne >>.WM_PAINT

		invoke GetClientRect,[hwnd],offset rect

		invoke GdipCreateFromHWND, [hwnd], offset pGraphics
		invoke GdipCreateBitmapFromGraphics,[rect.right], [rect.bottom],[pGraphics],offset pPic
		invoke GdipDeleteGraphics, [pGraphics]

		invoke SetWindowLong,[hwnd],GWL_USERDATA,[pPic]
		jmp >>.DEFPROC

	.WM_PAINT
	cmp D[uMsg],WM_PAINT
	jne >>.WM_LBUTTONDOWN
		invoke BeginPaint,[hwnd],offset ps
		invoke GetClientRect,[hwnd],offset rect
		invoke GdipCreateFromHDC,[ps.hdc], offset pGraphics
		invoke GdipSetPixelOffsetMode,[pGraphics],PixelOffsetModeHighQuality
		invoke GdipSetInterpolationMode,[pGraphics],InterpolationModeHighQualityBicubic
		invoke GdipDrawImageRectI,[pGraphics],[pPic],0,0,[rect.right], [rect.bottom]
		invoke GdipDeleteGraphics, [pGraphics]
		invoke EndPaint,[hwnd],offset ps
		xor eax,eax
		ret

	.WM_LBUTTONDOWN
		cmp D[uMsg],WM_LBUTTONDOWN
		jne >>.WM_LBUTTONUP

		.POINT_PEN
			invoke GetWindowRect,[hwnd],offset rect
			add D[rect.left],1
			add D[rect.top],1
			sub D[rect.right],1
			sub D[rect.bottom],1
			invoke ClipCursor,offset rect

			invoke GetCursorPos,offset Oldpt
			invoke ScreenToClient,[hwnd],offset Oldpt

			invoke GetWindowLong,[hwnd],0
			mov [color],eax

			mov D[rect.left],0
			mov D[rect.top],0
			invoke GdipGetImageHeight,[pPic],offset rect.bottom
			invoke GdipGetImageWidth,[pPic],offset rect.right

			invoke GdipBitmapLockBits,[pPic],offset rect,ImageLockModeWrite,PixelFormat32bppARGB,offset bmd

			invoke GdipSetBitmapPixel,[Oldpt.x],[Oldpt.y],[bmd.Scan0],[bmd.Width],[bmd.Height],[color]

			invoke GdipBitmapUnlockBits,[pPic],offset bmd

			invoke InvalidateRect,[hwnd],NULL,TRUE
			mov D[fDrawing],TRUE

			jmp >>.DEFPROC

	.WM_LBUTTONUP
		cmp D[uMsg],WM_LBUTTONUP
		jne >>.WM_MOUSEMOVE
			invoke ClipCursor,NULL
			mov D[fDrawing],FALSE
			jmp >>.DEFPROC

	.WM_MOUSEMOVE
		cmp D[uMsg],WM_MOUSEMOVE
		jne >>.WM_DESTROY

		.LINE
			cmp D[fDrawing],TRUE
			jne >>.DEFPROC
			invoke GetWindowLong,[hwnd],0
			mov [color],eax
			invoke GetCursorPos,offset pt
			invoke ScreenToClient,[hwnd],offset pt
			invoke GdipBitmapDrawLine,[pPic],[Oldpt.x],[Oldpt.y],[pt.x],[pt.y],[color]
			mov eax,[pt.x]
			mov [Oldpt.x],eax
			mov eax,[pt.y]
			mov [Oldpt.y],eax
			invoke InvalidateRect,[hwnd],NULL,TRUE

			jmp >>.DEFPROC

	.WM_DESTROY
	cmp D[uMsg],WM_DESTROY
	jne >>.DEFPROC
		invoke GetWindowLong,[hwnd],GWL_USERDATA
		invoke GdipDisposeImage,rax

	.DEFPROC
	invoke DefWindowProc, [hwnd], [uMsg], [wParam], [lParam]
	RET
ENDF

// Vector functions for gdiplus image object

GdipSetBitmapPixel FRAME x, y, pBits, width, height, color

	mov eax,[width]
	mov ecx,[height]

	cmp [x],eax
	jae >.EXIT

	cmp [y],ecx
	jae >.EXIT


	mov ecx,[x]
	shl ecx,2 ; 4*X
	mov eax,[y]
	shl eax,2 ; Width*4*Y
	mul D[width]
	add eax,ecx
	add eax,[pBits]
	mov edx,[color]
	mov [eax],edx
	ret

	sub ecx,[y]
	dec ecx
	mul ecx
	shl eax,2 ; adjust for DWORD size
	mov edx,eax

	mov eax,[x]
	shl eax,2 ; adjust for DWORD size
	add eax,edx

	add eax,[pBits] ; add the offset to the DIB bit
	mov ecx,[color]
	mov D[eax],ecx

	.EXIT
	RET
ENDF

GdipBitmapDrawLine FRAME pBitmapObject,x1,y1,x2,y2,color
	uses edi,esi,ebx
	LOCAL ix,iy,idx,idy,incx,incy,balance
	LOCAL bmd:BitmapData
	LOCAL rect	:RECT

	// Bresenham Line

	mov D[rect.left],0
	mov D[rect.top],0

	invoke GdipGetImageHeight,[pBitmapObject],offset rect.bottom
	invoke GdipGetImageWidth,[pBitmapObject],offset rect.right

	invoke GdipBitmapLockBits,[pBitmapObject],offset rect,ImageLockModeWrite,PixelFormat32bppARGB,offset bmd

	; Limit the drawing to the surface
	mov eax,[x1]	
	or eax,eax
	jns >
		xor eax,eax
	:
	cmp eax,[bmd.Width]
	jl >
		mov eax,[bmd.Width]
		dec eax
	:
	mov [x1],eax
	
	mov eax,[x2]
	or eax,eax
	jns >
		xor eax,eax
	:
	cmp eax,[bmd.Width]
	jl >
		mov eax,[bmd.Width]
		dec eax
	:
	mov [x2],eax

	mov eax,[y1]
	or eax,eax
	jns >
		xor eax,eax
	:
	cmp eax,[bmd.Height]
	jl >
		mov eax,[bmd.Height]
		dec eax
	:
	mov [y1],eax

	mov eax,[y2]
	or eax,eax
	jns >
		xor eax,eax
	:
	cmp eax,[bmd.Height]
	jl >
		mov eax,[bmd.Height]
		dec eax
	:
	mov [y2],eax


	// real drawing starts here

	mov ebx,[bmd.Scan0]

	mov eax,[x2]
	cmp eax,[x1]
	jl >
		sub eax,[x1]
		mov D[incx],1
		jmp >C1
	:
		mov eax,[x1]
		sub eax,[x2]
		mov D[incx],-1
	C1:
	mov [idx],eax
	
	mov eax,[y2]
	cmp eax,[y1]
	jl >
		sub eax,[y1]
		mov D[incy],1
		jmp >C1
	:
		mov eax,[y1]
		sub eax,[y2]
		mov D[incy],-1
	C1:
	mov [idy],eax
	
	mov eax,[x1]
	mov [ix],eax
	mov eax,[y1]
	mov [iy],eax

	mov eax,[idx]
	cmp eax,[idy]
	jl >>L1
		mov eax,[idy]
		mov ecx,[idx]

		shl eax,1
		mov [idy],eax

		sub eax,ecx
		mov [balance],eax

		shl ecx,1
		mov [idx],ecx

		mov edi,[ix]
		mov esi,[iy]
		jmp >W1
		W0:
			invoke GdipSetBitmapPixel,edi,esi,ebx,[bmd.Width],[bmd.Height],[color]
			cmp D[balance],0
			jl >
				add esi,[incy]
				mov eax,[idx]
				sub [balance],eax
			:
			mov eax,[idy]
			add [balance],eax
			add edi,[incx]
		W1:
		cmp edi,[x2]
		jne <W0
		invoke GdipSetBitmapPixel,edi,esi,ebx,[bmd.Width],[bmd.Height],[color]

		invoke GdipBitmapUnlockBits,[pBitmapObject],offset bmd
		xor eax,eax
		ret

	L1:
		mov eax,[idx]
		mov ecx,[idy]

		shl eax,1
		mov [idx],eax

		sub eax,ecx
		mov [balance],eax

		shl ecx,1
		mov [idy],ecx

		mov edi,[ix]
		mov esi,[iy]
		jmp >W4
		W3:
			invoke GdipSetBitmapPixel,edi,esi,ebx,[bmd.Width],[bmd.Height],[color]
			cmp D[balance],0
			jl >
				add edi,[incx]
				mov eax,[idy]
				sub [balance],eax
			:
			mov eax,[idx]
			add [balance],eax
			add esi,[incy]
		W4:
		cmp esi,[y2]
		jne <W3
		invoke GdipSetBitmapPixel,edi,esi,ebx,[bmd.Width],[bmd.Height],[color]

		invoke GdipBitmapUnlockBits,[pBitmapObject],offset bmd
		xor eax,eax

		ret
ENDF

GdipBitmapFillBackground FRAME pBitmapObject, color
	uses edi,esi
	LOCAL bmd:BitmapData
	LOCAL rect	:RECT

	mov D[rect.left],0
	mov D[rect.top],0

	invoke GdipGetImageHeight,[pBitmapObject],offset rect.bottom
	invoke GdipGetImageWidth,[pBitmapObject],offset rect.right

	invoke GdipBitmapLockBits,[pBitmapObject],offset rect,ImageLockModeWrite,PixelFormat32bppARGB,offset bmd
	
	mov edi,[bmd.Height]
	.ROW
	mov esi,[bmd.Width]
	dec edi
	test edi,edi
	js >.ENDFILL
	.COLUMN
	dec esi
	test esi,esi
	js .ROW
	mov ecx,esi
	shl ecx,2 ; 4*X
	mov eax,edi
	shl eax,2 ; Width*4*Y
	mul D[bmd.Width]
	add eax,ecx
	add eax,[bmd.Scan0]
	mov edx,[color]
	mov [eax],edx
	jmp .COLUMN

	.ENDFILL
	invoke GdipBitmapUnlockBits,[pBitmapObject],offset bmd
	RET
ENDF

// File ops

GdipSaveBitmapToFile FRAME pImage, pFileName, format, bitdepth, alpha
	LOCAL pPal				:%PTR
	LOCAL encoderClsid		:GUID
	LOCAL PalType			:%PTR
	LOCAL ImgFmt			:%PTR

// format constants
;#DEFINE GDIP_IMAGE_BMP 0
;#DEFINE GDIP_IMAGE_JPG 1
;#DEFINE GDIP_IMAGE_GIF 2
;#DEFINE GDIP_IMAGE_EMF 3
;#DEFINE GDIP_IMAGE_WMF 4
;#DEFINE GDIP_IMAGE_TIFF 5
;#DEFINE GDIP_IMAGE_PNG 6
;#DEFINE GDIP_IMAGE_ICON 7

	cmp D[format],GDIP_IMAGE_BMP
	jne >
		invoke memcopy,offset ImageEncoderBMP,offset encoderClsid,SIZEOF GUID
		jmp >>.ENCFOUND
	:
	cmp D[format],GDIP_IMAGE_JPG
	jne >
		invoke memcopy,offset ImageEncoderJPEG,offset encoderClsid,SIZEOF GUID
		jmp >>.ENCFOUND
	:
	cmp D[format],GDIP_IMAGE_GIF
	jne >
		invoke memcopy,offset ImageEncoderGIF,offset encoderClsid,SIZEOF GUID
		jmp >>.ENCFOUND
	:

;	cmp D[format],GDIP_IMAGE_EMF
;	jne >
;		invoke memcopy,offset ImageEncoderEMF,offset encoderClsid,SIZEOF GUID
;		jmp >>.ENCFOUND
;	:
;	cmp D[format],GDIP_IMAGE_WMF
;	jne >
;		invoke memcopy,offset ImageEncoderWMF,offset encoderClsid,SIZEOF GUID
;		jmp >>.ENCFOUND
;	:

	cmp D[format],GDIP_IMAGE_TIFF
	jne >
		invoke memcopy,offset ImageEncoderTIFF,offset encoderClsid,SIZEOF GUID
		jmp >>.ENCFOUND
	:
	cmp D[format],GDIP_IMAGE_PNG
	jne >
		invoke memcopy,offset ImageEncoderPNG,offset encoderClsid,SIZEOF GUID
		jmp >>.ENCFOUND
	:

	invoke IsBadReadPtr,[format],1
	test eax,eax
	jnz >>.ERRORFORMAT

	.GETENC
	invoke GetEncoderClsid,[format], offset encoderClsid
	test eax,eax
	js >>.ERRORFORMAT

	.ENCFOUND

	// The largest palette size is 1024 bytes so we allocate that
	invoke GdipAlloc,1024 + SIZEOF ColorPalette
	mov [pPal],eax

	cmp D[bitdepth],-1
	je >>.NoConvert

	cmp D[bitdepth],8
	jne >
		// Since this is an indexed type use a large palette to find the closest colors
		// it will be reduced to 256 colors by the conversion function
		mov D[PalType],PaletteTypeFixedHalftone27
		mov D[ImgFmt],PixelFormat8bppIndexed
		jmp >>.Convert
	:
	cmp D[bitdepth],24
	jne >
		mov D[PalType],PaletteTypeFixedHalftone27
		mov D[ImgFmt],PixelFormat24bppRGB
		jmp >>.Convert
	:
	cmp D[bitdepth],32
	jne >
		mov D[PalType],PaletteTypeFixedHalftone256
		cmp D[alpha],TRUE
		je >.USEALPHA
		mov D[ImgFmt],PixelFormat32bppRGB
		jmp >>.Convert
		.USEALPHA
		mov D[ImgFmt],PixelFormat32bppARGB
		jmp >>.Convert
	:

	cmp D[format],GDIP_IMAGE_BMP
	jne >>.NoConvert
	// Bitmap only color depths
	cmp D[bitdepth],16
	jne >
		// There is no standard 16Bpp palette so we use a 24 Bpp. It's not optimal but easier.
		mov D[PalType],PaletteTypeFixedHalftone27
		mov D[ImgFmt],PixelFormat16bppRGB555
		jmp >>.Convert
	:
	cmp D[bitdepth],48
	jne >
		mov D[PalType],PaletteTypeFixedHalftone256
		mov D[ImgFmt],PixelFormat48bppRGB
	:
	cmp D[bitdepth],64
	jne >.NoConvert
		mov D[PalType],PaletteTypeFixedHalftone256
		mov D[ImgFmt],PixelFormat64bppARGB

	.Convert
	invoke GdipInitializePalette,[pPal], [PalType], 0, TRUE, NULL

	invoke GdipBitmapConvertFormat,[pImage],[ImgFmt], DitherTypeNone,[PalType],[pPal],50.0
	.NoConvert

	invoke GdipSaveImageToFile,[pImage], [pFileName],offset encoderClsid,NULL
	test eax,eax
	jnz >>.NOSAVE

	invoke GdipDisposeImage,[pImage]

	invoke GdipFree,[pPal]
	invoke SetLastError,0
	xor eax,eax
	RET

	.NOIMG
	invoke SetLastError,ERROR_INVALID_HANDLE
	xor eax,eax
	dec eax
	RET

	.ERRORFORMAT
	invoke GdipDisposeImage,[pImage]
	invoke SetLastError,ERROR_NOT_SUPPORTED
	xor eax,eax
	dec eax
	RET

	.NOSAVE
	invoke GdipDisposeImage,[pImage]
	invoke GdipFree,[pPal]
	// GdipSaveImageToFile seems to set the error code properly so leave it
	xor eax,eax
	dec eax
	RET

	STRENCBMP:	DUS "image/bmp",0
	STRENCGIF:	DUS "image/gif",0
	STRENCJPG:	DUS "image/jpeg",0
	STRENCTIF:	DUS "image/tiff",0
	STRENCPNG:	DUS "image/png",0

ENDF

// Effects

GdipColorBalanceApplyEffect FRAME pBitmap,cyanRed,magentaGreen,yellowBlue
	LOCAL cbparams		:ColorBalanceParams
	LOCAL pEffect		:D
	LOCAL rect			:RECT

	mov eax,[cyanRed]
	mov [cbparams.cyanRed], eax
	mov eax,[magentaGreen]
	mov [cbparams.magentaGreen], eax
	mov eax,[yellowBlue]
	mov [cbparams.yellowBlue], eax

	lea eax,pEffect
	push eax
	pushguid(ColorBalanceEffectGuid)
	call GdipCreateEffect

	invoke GdipSetEffectParameters,[pEffect],offset cbparams,SIZEOF ColorBalanceParams

	mov D[rect.left],0
	mov D[rect.top],0
	invoke GdipGetImageWidth,[pBitmap],offset rect.right
	invoke GdipGetImageHeight,[pBitmap],offset rect.bottom

	invoke GdipBitmapApplyEffect,[pBitmap],[pEffect],offset rect, NULL,NULL,NULL
	invoke GdipDeleteEffect,[pEffect]
	RET
ENDF

GdipBrightnessContrastApplyEffect FRAME pBitmap,Brightness,Contrast
	LOCAL bcparams		:BrightnessContrastParams
	LOCAL pEffect		:D
	LOCAL rect			:RECT

	mov eax,[Brightness]
	mov [bcparams.brightnessLevel], eax
	mov eax,[Contrast]
	mov [bcparams.contrastLevel], eax

	lea eax,pEffect
	push eax
	pushguid(BrightnessContrastEffectGuid)
	call GdipCreateEffect

	invoke GdipSetEffectParameters,[pEffect],offset bcparams,SIZEOF BrightnessContrastParams

	mov D[rect.left],0
	mov D[rect.top],0
	invoke GdipGetImageWidth,[pBitmap],offset rect.right
	invoke GdipGetImageHeight,[pBitmap],offset rect.bottom

	invoke GdipBitmapApplyEffect,[pBitmap],[pEffect],offset rect, NULL,NULL,NULL
	invoke GdipDeleteEffect,[pEffect]
	RET
ENDF

GdipBlurApplyEffect FRAME pBitmap,radius
	LOCAL blurparams	:BlurParams
	LOCAL pEffect		:D
	LOCAL rect			:RECT

	mov eax,[radius]
	mov D[blurparams.radius], eax
	mov D[blurparams.expandEdge], FALSE

	lea eax,pEffect
	push eax
	pushguid(BlurEffectGuid)
	call GdipCreateEffect

	invoke GdipSetEffectParameters,[pEffect],offset blurparams,SIZEOF BlurParams

	mov D[rect.left],0
	mov D[rect.top],0
	invoke GdipGetImageWidth,[pBitmap],offset rect.right
	invoke GdipGetImageHeight,[pBitmap],offset rect.bottom

	invoke GdipBitmapApplyEffect,[pBitmap],[pEffect],offset rect, NULL,NULL,NULL
	invoke GdipDeleteEffect,[pEffect]
	RET
ENDF

// Utilities

GetEncoderClsid FRAME format, pClsid
	uses edi,ebx,esi
	LOCAL num	:D	// number of image encoders
	LOCAL size	:D	// size of the image encoder array in bytes
	LOCAL pImageCodecInfo	:D

	mov D[num],0
	mov D[size],0

	invoke GdipGetImageEncodersSize, offset num, offset size
	cmp D[size],0
	je >>.ERROR

	invoke GdipAlloc,[size]
	mov [pImageCodecInfo],eax
	test eax,eax
	jz >>.ERROR

	// Scan through the codecs
	invoke GdipGetImageEncoders,[num],[size],[pImageCodecInfo]
	xor ebx,ebx
	dec ebx

	.NEXTCODEC
	inc ebx
	cmp ebx,[num]
	jg >.EXIT
		imul esi,ebx,SIZEOF ImageCodecInfo
		add esi,ImageCodecInfo.MimeType
		add esi,[pImageCodecInfo]
		invoke lstrcmpiW,[esi],[format]
		test eax,eax
		jnz <.NEXTCODEC
			imul esi,ebx,SIZEOF ImageCodecInfo
			add esi,[pImageCodecInfo]
			add esi, ImageCodecInfo.Clsid
			invoke memcopy,esi,[pClsid],SIZEOF GUID
			invoke GdipFree,[pImageCodecInfo]
			mov eax,ebx
			ret
	.EXIT

	invoke GdipFree,[pImageCodecInfo]
   .ERROR
   xor eax,eax
   dec eax
   ret
ENDF

memcopy FRAME lpSource,lpDest,nBytes
	uses edi,esi,ecx
	cld
	mov edi,[lpDest]
	mov esi,[lpSource]
	mov ecx,[nBytes]
	
	; do the evenly divisible ones
	shr ecx,2
	rep movsd
	
	; do the remainder
	mov ecx,[nBytes]
	and ecx,3
	rep movsb
	
	RET
ENDF
